#
# spec file for package intel-media-driver
#
# Copyright (c) 2020 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define so_ver	7

Name:           intel-media-driver
Version:        19.2.1
Release:        lp152.3.3
Summary:        Intel Media Driver for VAAPI
License:        MIT AND BSD-3-Clause
Group:          System/Libraries
URL:            https://github.com/intel/media-driver
Source:         https://github.com/intel/media-driver/archive/intel-media-%{version}.tar.gz
Source1:        generate-supplements.sh
Patch0:         Werror-implicit-function-not-valid-for-C++.patch
Patch1:         Werror-initialize-in-right-order.patch
Patch2:         U_Encode-Add-some-missing-device-IDs-for-CML-and-ICL.patch
BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(igdgmm)
BuildRequires:  pkgconfig(libva) >= 1.4.1
BuildRequires:  pkgconfig(pciaccess)
ExclusiveArch:  x86_64
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001602sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001606sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000160Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000160Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000160Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000160Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001612sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001616sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000161Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000161Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000161Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000161Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001622sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001626sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000162Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000162Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000162Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000162Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000163Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001902sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001906sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000190Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000190Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000190Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001912sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001913sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001915sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001916sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001917sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000191Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000191Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000191Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000191Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001921sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001923sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001926sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001927sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000192Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000192Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000192Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001932sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000193Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000193Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000193Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001A84sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00001A85sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003184sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003185sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E90sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E91sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E92sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E93sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E94sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E96sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E98sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E99sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E9Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E9Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003E9Csv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA0sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA1sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA2sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA3sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA4sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA5sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA6sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA7sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA8sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00003EA9sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005902sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005906sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005908sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000590Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000590Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000590Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005912sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005913sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005915sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005916sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005917sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000591Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000591Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000591Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000591Esv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005921sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005923sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005926sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005927sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000592Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000592Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005932sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000593Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A41sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A42sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A44sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A49sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A4Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A50sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A51sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A52sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A54sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A59sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A5Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A5Csv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A84sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00005A85sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A50sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A51sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A52sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A53sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A56sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A57sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A58sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A59sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A5Asv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A5Bsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A5Csv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A5Dsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00008A71sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009B21sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009B41sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BA0sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BA2sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BA4sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BA5sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BA8sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BAAsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BABsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BACsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BC0sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BC2sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BC4sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BC5sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BC8sv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BCAsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BCBsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d00009BCCsv*sd*bc*sc*i*)
Supplements:    modalias(xorg-x11-server:pci:v00008086d0000FF05sv*sd*bc*sc*i*)

%description
The Intel Media Driver for VAAPI is a new VA-API (Video Acceleration API)
user mode driver supporting hardware accelerated decoding, encoding, and
video post processing for GEN based graphics hardware.

%package -n libigfxcmrt%{so_ver}
Summary:        Intel Graphics C for Media Runtime Library
License:        MIT
Group:          System/Libraries

%description -n libigfxcmrt%{so_ver}
cmrtlib is a runtime library for Intel GPU render engine.

%package -n libigfxcmrt-devel
Summary:        Development files for Intel Graphics C for Media Runtime Library
License:        MIT
Group:          Development/Libraries/C and C++
Requires:       libigfxcmrt%{so_ver} = %{version}

%description -n libigfxcmrt-devel
cmrtlib is a runtime library for Intel GPU render engine.

This package contains the development headers for the library found in
libigfxcmrt%{so_ver}.

%prep
%setup -q -c -a 0
mv media-driver-* media-driver
chmod -x media-driver/*.md
pushd media-driver
%patch0 -p1
%patch1 -p1
%patch2 -p1
popd

%define __sourcedir media-driver

%build
srcroot=`pwd`
%cmake -DBUILD_SHARED_LIBS:BOOL=OFF
%make_jobs

%install
%cmake_install

# create a profile for exporting LIBVA_DRIVER_NAME variable
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
echo "export LIBVA_DRIVER_NAME=iHD" > %{buildroot}%{_sysconfdir}/profile.d/intel-media-driver.sh
echo "setenv LIBVA_DRIVER_NAME iHD" > %{buildroot}%{_sysconfdir}/profile.d/intel-media-driver.csh

%files
%doc media-driver/README.md
%license media-driver/LICENSE.md
%{_libdir}/dri
%{_sysconfdir}/profile.d/*

%files -n libigfxcmrt%{so_ver}
%{_libdir}/libigfxcmrt.so.%{so_ver}
%{_libdir}/libigfxcmrt.so.%{so_ver}.*

%files -n libigfxcmrt-devel
%doc media-driver/cmrtlib/README.md
%{_includedir}/igfxcmrt
%{_libdir}/libigfxcmrt.so
%{_libdir}/pkgconfig/igfxcmrt.pc

%changelog
* Tue Feb 25 2020 Stefan Dirsch <sndirsch@suse.com>
- generate-supplements.sh/specfile: fixed supplements lines
  (boo#1164851)
* Thu Jan 16 2020 Stefan Dirsch <sndirsch@suse.com>
- U_Encode-Add-some-missing-device-IDs-for-CML-and-ICL.patch
  * add support for support AML-Y (bsc#1160967)
* Thu Nov  7 2019 Stefan Dirsch <sndirsch@suse.com>
- This release fullfills requirements for jsc#SLE-8838
* Mon Sep  2 2019 Stefan Dirsch <sndirsch@suse.com>
- Update to version 19.2.1
  * Fixed known GPU hang issue when encoding 444 8/10bit in ICL
    issue#677
  * Fixed several compile warnings.
- Werror-implicit-function-not-valid-for-C++.patch,
  Werror-initialize-in-right-order.patch
  * needed as buildfixes
* Sat Jul  6 2019 Bjørn Lie <bjorn.lie@gmail.com>
- Update to version 19.2.0:
  * Release pVEInterf to fix the mem leak issue.
  * Fix memory leak during 3D surface allocation.
  * Move the lock earlier to make surface heap status aligned when
    surface is destroyd.
  * [VP] UMD_OCA Implement:
  - Add UMD_OCA support in mos.
  - Add UMD_OCA support for VP RCS case (No CM based) and
    Vebox/SFC case.
  - It is disabled by default.
  * [VP] Remove dupliatcated defines on composition.
  * Remove duplicated defines and revert part codes.
  * Full support of Gen9 CML kernel integration.
  * Stay the same compile option as Gen9.
  * Readme: update feature list for default and open source build
  * [Encode]:
  - Fix segment fault issue in Jpeg encode cases on Linux.
  - Fix Dynamic Scaling Media Reset Issue.
- Update modalias supplements.
* Mon Apr  1 2019 tiwai@suse.de
- Updated to version 18.4.1:
  * Supported Platforms:
  - BDW/SKL/APL(BXT)/KBL/CFL/WHL/CNL/ICL
  * Improvements:
  - WHL: Added WHL support and enabled its VP8 encoding.
  - ICL: Added ICL open source compute shaders for video processing.
    Enabled ICL HDR10 Tone Mapping using close source compute shaders.
  - DRM uAPI relative code is refactored to better comply to i915
    Open Source Userspace Requirement.
  - Added X11 build option detection.
  - Enabled software swizzling support to improve surface reading
    performance of vaGetImage.
  - Added ARGB,Y410 image format support.
  - Added versioning information to CMRT library.
  - BRC enhancement:
    AVC hardware encoding: added QVBR support.
    AVC shader encoding: added AVBR and max frame size BRC support.
    VP8 encoding: corrected fps calculation error.
  * Fixed issues:
  - GStreamer/gstreamer-vaapi integration:
    Fixed the issue about KBL HEVC P010_10LE encoding kernel state
    initialization failure for CODECHAL_HEVC_MBENC_PENC.
    Fixed the issue about aspect ratio being unable to retain in
    video processsing PutSurface for vaapisink display.
  - Corrected RT format reporting for HEVC main10 profile.
  - Corrected caps reporting of max width/height for VP9 decoding
    from 2k (2048x2048) to 8k (8192x8192).
- Add sub-packages libigfxcmrt7 and libigfxcmrt-devel
- Updated supplements accordingly
* Tue Nov 13 2018 sndirsch@suse.com
- added hardware supplements in order to install the package on
  appropriate hardware (Broadwell, Skylake, Broxton/Apollo Lake,
  Kaby Lake, Coffee Lake, Cannonlake, Ice Lake at this time)
- added script to generate the above information easily
* Wed Nov  7 2018 tiwai@suse.de
- Updated to version 18.3.0:
  * Adding ICL support
  * Adding dynamic loading support of Gmmlib
  * Better support to ffmpeg and gstreamer:
    + AVC low power encoding
    + MPEG2 encoding
    + VP8 decoding
    + VC1 decoding
    + JPEG encoding and decoding
  * Adding Dockerfile and docker images
- Use shared lib of gmmlib; added buildreq accordingly
* Tue Jul 10 2018 tiwai@suse.de
- initial package: media-driver Q2'18 release
